
module Main where

open import Prelude
open import Type
open import TypeCheck
open import Term
open import Term.Show
open import Term.Eval

showVal : ∀ {a} → Term [] a → String
showVal {a = nat} t = show (eval t [])
showVal _ = "<function>"

main : IO ⊤
main =
  getProgName >>= λ prog →
  getArgs >>= λ
  { (file ∷ []) →
    readFile file >>= λ s →
    case checkString s of λ
    { (left  err)     → putStrLn $ "Error: " & err
    ; (right (a , t)) → putStrLn $ "Type: " & show a & "\nTerm: " & show t & "\nVal:  " & showVal t }
  ; _ → putStrLn $ "Usage: " & prog & " FILE"
  }
